<template>
  <v-list-item v-if="rendered">
    <v-list-item-icon>
      <v-icon>mdi-account-lock</v-icon>
    </v-list-item-icon>
    <v-list-item-content>
      <v-list-item-title>{{ $t('button.block-user') }}</v-list-item-title>
    </v-list-item-content>
    <v-list-item-content>
      <v-switch
        v-model="toggled"
        color="red darken-3"
        @change="block"
      />
    </v-list-item-content>
  </v-list-item>
</template>

<script lang="ts">
import type { Client } from '@/client';
import axios from 'axios';
import { Vue, Component, Prop } from 'vue-property-decorator';

@Component
export default class BlockUsersButton extends Vue {
  who = 'amiral';

  toggled = false;

  rendered = false;

  root = false;

  @Prop({ default: null })
  client!: Client | null;

  groups = ['amiral'];

  async created() {
    this.rendered = false;
    // eslint-disable-next-line max-len
    // this.rendered = this.client?.user?.name !== undefined && !this.groups.includes(this.client?.user?.name);
  }

  async block() {
    await axios.put(
      `${process.env.VUE_APP_CORPUS_URL_NEW}/auth/%2F/grant`,
      { users: [this.who], verb: 'no-read-analysis', action: this.toggled },
      {
        headers: {
          Authorization: `Bearer ${this.client?.user?.token}`,
        },
      },
    )
      // eslint-disable-next-line no-console
      .catch((error) => console.warn(error));
  }
}
</script>
